exception Empty

type 'a t

val nil : 'a t

val create : unit -> 'a t

val push : 'a t -> 'a -> 'a t

val pop : 'a t -> ('a * 'a t)

val from_list : 'a list -> 'a t

val to_list : 'a t -> 'a list

val is_empty : 'a t -> bool
 
val add_as_first : 'a t -> 'a -> 'a t

val map : ('a -> 'b) -> 'a t -> 'b t

val iter : ('a -> unit) -> 'a t -> unit
